local LB = LibStub:GetLibrary("LibBoss-1.0") -- Depend on ATLAS for this being there

local CDGBDL = ZO_Object:Subclass()

local Addon =
{
    Name = "CDGBossDropLogger",
    NameSpaced = "CDG Boss Drop Logger",
    Author = "CrazyDutchGuy",
    Version = "1.28",
}

local CDGBDL_VARS = {
	addonName = [[CDGBossDropLogger]]
}

local LOOTQUALITY = {
	JUNK = 0,
	NORMAL = 1,
	FINE = 2,
	SUPERIOR = 3,
	EPIC = 4,
	LEGENDARY = 5,
} 

local BOSSDROPZONES = {}

local CDGBDL_SV = {}

local lastDetectedBoss = ""
local lastDetectedTime = GetTimeStamp()

local linesSend = 0
local mailCounter = 0

local ignoreList = 
{
	16424, -- Racial Motifs 1: The High Elves 
	16425, -- Kulturelle Stile der Völker 5: Die Bretonen 
	16427, -- Racial Motifs 6: The Redguards
	27244, -- Kulturelle Stile der Völker 4: Die Nord 
	27245,
	27246, -- Racial Motifs 9: The Argonians
	43620, -- Bangkorai Treasure Map II
	43624,
	43721, -- Craglorn Treasure Map I
	43722,
	43723, -- Craglorn Treasure Map III
	43724,
	44698, -- Racial Motifs 7: The Khajiit
--	45018, -- voidsteel axe 
--	45019, -- voidsteel mace
--	45021, -- voidsteel battle axe
--	45022,
--	45023,
--	45024, -- voidsteel dagger
--	45025,
--	45027,
--	45028, -- voidsteel helm  
--	45030,
--	45031,
--	45032, -- shadowspun robe
--	45033,
--	45034,
--	45035, -- shadowspun hat
--	45036, -- silverweave breeches
--	45037, -- Kresh Jerkin
--	45038, -- shadowspun epaulets
--	45039,
--	45040,
--	45041,
--	45042,
--	45043,
--	45044, -- shadowhide helmet
--	45045,
--	45046, -- shadowhide arm cops
--	45047, -- shadowhide belt
--	45048, -- nightwood shield 
--	45049, -- nightwood inferno staff
--	45050, -- yew ice staff
--	45051, -- nightwood lightning staff
--	45052, -- nightwood restoration staff
--	45054,
--	45055,
--	45057,
--	45058,
--	45060,
--	45061, -- voidsteel sabatons
--	45062, -- Quicksilver Gauntlets
--	45063,
--	45064, -- voidsteel greaves
--	45065, -- voidsteel pauldron
--	45066,
--	45072,
--	45073,
--	45074, -- Silverweave Sash
--	45075,
--	45076,
--	45081, -- ShadowHide Arm Cops
--	45082,
--	45083,
--	45084, -- nightwood inferno staff
--	45085, -- nightwood ice staff
--	45086, -- nightwood lightning staff 
--	45087, -- nightwood restoration staff
--	45088, -- voidsteel axe
--	45090,
--	45091,
--	45093,
--	45094, -- voidsteel dagger
--	45095,
--	45096, -- Voidsteel Sabatons
--	45097, -- voidsteel gauntlets
--	45098,
--	45099, -- voidsteel greaves
--	45100, -- voidsteel pauldrons
--	45101, -- voidsteel girdle
--	45103, -- shadowspun shoes
--	45104, -- shadowspun gloves
--	45105,
--	45107,
--	45108,
--	45110, -- nightwood bow
--	45111,
--	45112,
--	45113,
--	45117, -- Superb Belt
--	45118, -- nightwood shield
--	45119,
--	45121,
--	45122,
--	45123,
--	45124,
--	45128,
--	45130,
--	45131,
--	45132,
--	45133, -- VoidSteel Helm
--	45134, -- voidsteel greaves
--	45135,
--	45136,
--	45140,
--	45142,
--	45143,
--	45144,
--	45146,
--	45147,
--	45148, -- shadowhide bracers
--	45149, -- shadowhide helmet	
--	45150, -- shadowhide guards
--	45151, -- shadowhide arm cops
--	45152, -- shadowhide belt
--	45153, -- nightwood shield
--	45154,
--	45155,
--	45156,
--	45157, -- 
--	45158,
--	45159, -- voidsteel mace 
--	45160,
--	45162,
--	45163, -- voidsteel greatsword
--	45165,
--	45168,
--	45169,	
--	45172,
--	45177,
--	45179,
--	45180,
--	45181,
--	45184,
--	45185,
--	45186,
--	45187, -- Shadowspn Robe
--	45188, -- nightwood shield
--	45189,
--	45190, -- nightwood ice staff
--	45191, -- nightwood lightning staff
--	45192, -- nightwood restoration staff
--	45193,
--	45194,
--	45195,
--	45196,
--	45199, -- voidsteel dagger 
--	45201,
--	45207,
--	45208,
--	45209, -- shadowspun gloves
--	45210,
--	45211, -- shadowspun breeches
--	45212, -- shadowspun jerkin
--	45213, -- shadowspun epaulets
--	45214, -- shadowspun sash
--	45215, -- nightwood bow 
--	45216, -- shadowhide jack
--	45219,
--	45220, -- shadowhide guards
--	45221,
--	45222,
--	45223,
--	45225,
--	45228, -- voidsteel axe
--	45230,
--	45231,
--	45233,
--	45237,
--	45239,
--	45243,
--	45245,
--	45246,
--	45248,
--	45249,
--	45250,
--	45251,
--	45252, -- shadowhide boots
--	45253, -- Ironhide Bracers
--	45254,
--	45255,
--	45256,
--	45257, -- shadowhide belt
--	45258,
--	45259, -- nightwood inferno staff
--	45260,
--	45261,
--	45262,
--	45263,
--	45264, -- voidsteel mace
--	45265, -- voidsteel sword
--	45266,
--	45267, -- voidsteel maul
--	45268, -- voidsteel greatsword 
--	45269, -- voidsteel dagger
--	45270,
--	45274,
--	45277, -- shadowspun robe
--	45275,
--	45278,
--	45280,
--	45281,
--	45282, -- shadowspun jerkin 
--	45283,
--	45284,
--	45285, 
--	45286,
--	45287,
--	45289,
--	45290,
--	45292,
--	45293,
--	45294,
--	45295, -- beech ice staff
--	45296, -- ash lightning staff
--	45297,
	45535, -- enriched Eye-Opener Recipe
	45610, --enriched White Eye Recipe 
	45615,
	45626, -- consummate Bervez Wine Recipe
	45627,
	45629,
	45631,
	45660,
	45699,
	45709, -- enriched Fishy Sticks Recipe 
	45714, -- Rezept: brüchiger Honig der Vollendung
	45715,
	45716,
	45717, -- fortified Sweetroll Recipe
	45718, -- invigorated Honey Pudding Recipe
	45804,
	45852, -- Denata (rune)
	45853,
	45854, -- Kuta
	45858,
	54184, -- Magnificent Bat Pelt
	54210, -- Prized Barb
	54221,
	54232, -- Crackling Lodestone
	54234, -- Daedric Dewclaw
	54236, -- Blighted Iron Collar
	54242, -- fortified  Bervez Lager Recipe
	54338, -- Scaly Durzog Pelt 
	54508, -- diamond ring
	54509,
	54510,
	54512,
	54513, -- diamond necklace
	54514, -- Diamond Necklace
}
local function isIgnoredItemID(itemID)
	if tonumber(itemID) >= 45018 and tonumber(itemID) <= 45297 then return true end

	for _,ignoreID in pairs(ignoreList) do
		if ignoreID == tonumber(itemID) then
			return true
		end
	end

	return false
end
--
-- This is a not perfect as we not allways have a loot target, especially if we are not looting ourselves
--
function CDGBDL:EVENT_LOOT_RECEIVED(eventCode, lootedBy, itemName, quantity, itemSound, lootType, self)	
	if self then
		-- Don't bother with low quality stuff
		if GetItemLinkQuality(itemName) < LOOTQUALITY.SUPERIOR then return end
		-- Don't record for zones that don't contain bosses
		local mapTexture = GetMapTileTexture()		
		if not LB:knownZone(mapTexture) then return end
		-- if it is on the ignoreList, then ignore it ...
		local itemID = select(4,ZO_LinkHandler_ParseLink(itemName))
	
		if isIgnoredItemID(itemID) then return end
	
		local lootDropTime = GetTimeStamp()
		-- Check if this is a familiar zone, else don't record
		if lastDetectedBoss and lastDetectedBoss ~= "" and (GetDiffBetweenTimeStamps(GetTimeStamp(),lastDetectedTime) < 300 ) then -- If killed within 5 minutes of detection assume it to be from the boss
			if not LB:knownLoot(mapTexture, itemName, lastDetectedBoss) then
				d("ATLAS Discovered drop " .. itemName .. " for boss " .. lastDetectedBoss)
				table.insert( CDGBDL_SV["log"], GetDate().. " " .. Addon.Version .. " " .. LB:getVersion() .. "::" .. mapTexture .. "::" .. itemName .. "::" .. lastDetectedBoss .. "::")
			end
		elseif not LB:knownLoot(mapTexture, itemName, nil) then -- Else assume it to be zome zone loot and check all bossess if we know the item.
			d("ATLAS Discovery : " .. itemName)
			table.insert( CDGBDL_SV["log"], GetDate().. " " .. Addon.Version .. " " .. LB:getVersion() .. "::" .. mapTexture .. "::" .. itemName .. "::")
		end
	end
end
--
-- Check if we found this boss before and add it to the saved vars
--
local function findBoss(name)
	lastDetectedBoss = name
	lastDetectedTime = GetTimeStamp()

	SetMapToPlayerLocation()
	local x,y, _ = GetMapPlayerPosition("player")	
	x = string.format("%.4f", x)
	y = string.format("%.4f", y)	

	if not LB:knownBoss(name, x, y) then
		--
		-- To prevent boss groups from flooding logs. Far from perfect ....
		--
		if #CDGBDL_SV["log"] > 1 then
			local secondLastSavedName = string.match(CDGBDL_SV["log"][#CDGBDL_SV["log"] - 1],".+::.+::(.+)::.+::.+::.+::")
			if secondLastSavedName == name then 
				table.remove(CDGBDL_SV["log"],#CDGBDL_SV["log"] - 1)
			end
		end

		if #CDGBDL_SV["log"] > 0 then
			local lastSavedName = string.match(CDGBDL_SV["log"][#CDGBDL_SV["log"]],".+::.+::(.+)::.+::.+::.+::")
			if lastSavedName == name then 
				table.remove(CDGBDL_SV["log"],#CDGBDL_SV["log"])
			end
		end
		
	
		local zone = GetUnitZone("player")
		local mapTexture = GetMapTileTexture()
		local texture = ZO_WorldMapContainer1:GetTextureFileName()
		table.insert( CDGBDL_SV["log"], GetDate().. " " .. Addon.Version .. " " .. LB:getVersion() .. "::" .. zone .. "::" .. name .. "::" .. x .. "::" .. y .. "::"  .. mapTexture .. "::")	
		
	
	end	
end
--
-- Look for boss names
--
function CDGBDL:EVENT_BOSSES_CHANGED(...)
	for i = 1, 6 do
		if DoesUnitExist("boss"..i) then
			findBoss(GetUnitName("boss"..i))
		end
	end
end


local function syncWithAddonAuthor()
-- Uncomment below to sync again, dont forget to change account name
--	if GetCVar("AccountName") == "YourAccountName" then return end
--	local maxLen = 700
--	local mailMessage = ""	
--
--	RequestOpenMailbox()        
--	for i,value in pairs (CDGBDL_SV["log"]) do
--		if ( string.len(mailMessage) + string.len(value) ) >= maxLen then
--			mailCounter = mailCounter + 1
--			d("Sending sync mail #"..mailCounter.." ATLAS " .. Addon.Version)			
--			SendMail("@YourAccountName", "ATLAS DATA SYNC ".. Addon.Version .. " " .. LB:getVersion() .. " #"..mailCounter,  mailMessage )  	
--			return					
--		else
--			mailMessage = mailMessage .. value
--			linesSend = linesSend + 1
--		end   		
--	end
--	linesSend = 0	
end

local function clearLogs()
-- Uncomment below to sync again, dont forget to change account name
--	if GetCVar("AccountName") == "YourAccountName" then return end
--	if linesSend <= 0 then return end
--
--	for i,v in pairs( CDGBDL_SV["log"] ) do
--	   CDGBDL_SV["log"][i] = nil
--	   linesSend = linesSend - 1
--	   if linesSend == 0 then break end
--        end
--
--	linesSend = 0
end

function CDGBDL:EVENT_PLAYER_ACTIVATED(...)
	for _ in pairs( CDGBDL_SV["log"] ) do
	   syncWithAddonAuthor()		
	   break
	end

	EVENT_MANAGER:UnregisterForEvent( CDGBDL_VARS.addonName, EVENT_PLAYER_ACTIVATED )	

end

function CDGBDL:EVENT_MAIL_SEND_SUCCESS(...)
	clearLogs()
	syncWithAddonAuthor()
end

function CDGBDL:EVENT_ADD_ON_LOADED(eventCode, addOnName, ...)	
	if addOnName == CDGBDL_VARS.addonName then		
		CDGBDL_SV = ZO_SavedVars:New(CDGBDL_VARS.addonName.."_SavedVariables", 3, nil, {}) 		
		if not CDGBDL_SV["boss"] then CDGBDL_SV["boss"] = {} end
		if not CDGBDL_SV["log"] then CDGBDL_SV["log"] = {} end
	
	
		EVENT_MANAGER:RegisterForEvent(CDGBDL_VARS.addonName, EVENT_PLAYER_ACTIVATED, function(...) CDGBDL:EVENT_PLAYER_ACTIVATED(...) end )
		EVENT_MANAGER:RegisterForEvent(CDGBDL_VARS.addonName, EVENT_BOSSES_CHANGED, function(...) CDGBDL:EVENT_BOSSES_CHANGED(...) end )
		EVENT_MANAGER:RegisterForEvent(CDGBDL_VARS.addonName, EVENT_LOOT_RECEIVED, function(...) CDGBDL:EVENT_LOOT_RECEIVED(...) end)	

		EVENT_MANAGER:RegisterForEvent(CDGBDL_VARS.addonName, EVENT_MAIL_SEND_SUCCESS, function(...) CDGBDL:EVENT_MAIL_SEND_SUCCESS(...) end )
	
		EVENT_MANAGER:UnregisterForEvent( CDGBDL_VARS.addonName, EVENT_ADD_ON_LOADED )

	end
end

function CDGBDL_OnInitialized()	
	EVENT_MANAGER:RegisterForEvent(CDGBDL_VARS.addonName, EVENT_ADD_ON_LOADED, function(...) CDGBDL:EVENT_ADD_ON_LOADED(...) end )			
end
